#!/usr/bin/perl

use strict;

sub monitor {
	my $rc;
	$rc = system( "pgrep -x $_[ 0 ] >/dev/null 2>&1" );
	$rc >>= 8;
	return $rc;
}

sub monitor_loop {
	my ( $status, $rc );
	my $proc = $_[ 0 ];

	if ( monitor( $proc ) == 0 ) {
		$status = "up";
	} else {
		$status = "down";
	}

	while ( 1 ) {
		$rc = monitor( $proc );
		if ( $rc == 0 && $status ne "up" ) {
			$status = "up";
			system( "logger -t kanshi " . $proc . " is up." );
		}
		if ( $rc != 0 && $status ne "down" ) {
			$status = "down";
			system( "logger -t kanshi " . $proc . " is down." );
		}
		sleep 10;
	}
}

MAIN: {
	my $proc;
	my @targets = ( "httpd", "postmaster" );

	foreach $proc ( @targets ) {
		if ( fork() == 0 ) {
		# Child
			monitor_loop( $proc );
			exit 0;
		}
		# Parent
	}
}
